CMSIS-DSP: Finite Impulse Response (FIR) Filters

| CMSIS-DSP Version 1.4.7 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Finite Impulse Response (FIR) Filters
Filtering Functions

## Functions
void | arm_fir_f32 (const arm_fir_instance_f32 *S, float32_t *pSrc, float32_t *pDst, uint32_t blockSize)
| Processing function for the floating-point FIR filter.
void | arm_fir_fast_q15 (const arm_fir_instance_q15 *S, q15_t *pSrc, q15_t *pDst, uint32_t blockSize)
| Processing function for the fast Q15 FIR filter for Cortex-M3 and Cortex-M4.
IAR_ONLY_LOW_OPTIMIZATION_ENTER void | arm_fir_fast_q31 (const arm_fir_instance_q31 *S, q31_t *pSrc, q31_t *pDst, uint32_t blockSize)
| Processing function for the fast Q31 FIR filter for Cortex-M3 and Cortex-M4.
void | arm_fir_init_f32 (arm_fir_instance_f32 *S, uint16_t numTaps, float32_t *pCoeffs, float32_t *pState, uint32_t blockSize)
| Initialization function for the floating-point FIR filter.
arm_status | arm_fir_init_q15 (arm_fir_instance_q15 *S, uint16_t numTaps, q15_t *pCoeffs, q15_t *pState, uint32_t blockSize)
| Initialization function for the Q15 FIR filter.
void | arm_fir_init_q31 (arm_fir_instance_q31 *S, uint16_t numTaps, q31_t *pCoeffs, q31_t *pState, uint32_t blockSize)
| Initialization function for the Q31 FIR filter.
void | arm_fir_init_q7 (arm_fir_instance_q7 *S, uint16_t numTaps, q7_t *pCoeffs, q7_t *pState, uint32_t blockSize)
| Initialization function for the Q7 FIR filter.
void | arm_fir_q15 (const arm_fir_instance_q15 *S, q15_t *pSrc, q15_t *pDst, uint32_t blockSize)
| Processing function for the Q15 FIR filter.
void | arm_fir_q31 (const arm_fir_instance_q31 *S, q31_t *pSrc, q31_t *pDst, uint32_t blockSize)
| Processing function for the Q31 FIR filter.
void | arm_fir_q7 (const arm_fir_instance_q7 *S, q7_t *pSrc, q7_t *pDst, uint32_t blockSize)
| Processing function for the Q7 FIR filter.

## Description

This set of functions implements Finite Impulse Response (FIR) filters for Q7, Q15, Q31, and floating-point data types. Fast versions of Q15 and Q31 are also provided. The functions operate on blocks of input and output data and each call to the function processes `blockSize` samples through the filter. `pSrc` and `pDst` points to input and output arrays containing `blockSize` values.

Algorithm:
  The FIR filter algorithm is based upon a sequence of multiply-accumulate (MAC) operations. Each filter coefficient `b[n]` is multiplied by a state variable which equals a previous input sample `x[n]`.

           y[n] = b[0] * x[n] + b[1] * x[n-1] + b[2] * x[n-2] + ...+ b[numTaps-1] * x[n-numTaps+1]

  Finite Impulse Response filter

  `pCoeffs` points to a coefficient array of size `numTaps`. Coefficients are stored in time reversed order.

           {b[numTaps-1], b[numTaps-2], b[N-2], ..., b[1], b[0]}

  `pState` points to a state array of size `numTaps + blockSize - 1`. Samples in the state buffer are stored in the following order.

           {x[n-numTaps+1], x[n-numTaps], x[n-numTaps-1], x[n-numTaps-2]....x[0], x[1], ..., x[blockSize-1]}

  Note that the length of the state buffer exceeds the length of the coefficient array by `blockSize-1`. The increased state buffer length allows circular addressing, which is traditionally used in the FIR filters, to be avoided and yields a significant speed improvement. The state variables are updated after each block of data is processed; the coefficients are untouched.

Instance Structure
  The coefficients and state variables for a filter are stored together in an instance data structure. A separate instance structure must be defined for each filter. Coefficient arrays may be shared among several instances while state variable arrays cannot be shared. There are separate instance structure declarations for each of the 4 supported data types.

Initialization Functions
  There is also an associated initialization function for each data type. The initialization function performs the following operations:
  - Sets the values of the internal structure fields.
  - Zeros out the values in the state buffer. To do this manually without calling the init function, assign the follow subfields of the instance structure: numTaps, pCoeffs, pState. Also set all of the values in pState to zero.

  Use of the initialization function is optional. However, if the initialization function is used, then the instance structure cannot be placed into a const data section. To place an instance structure into a const data section, the instance structure must be manually initialized. Set the values in the state buffer to zeros before static initialization. The code below statically initializes each of the 4 different data type filter instance structures

      *arm_fir_instance_f32 S = {numTaps, pState, pCoeffs};
      *arm_fir_instance_q31 S = {numTaps, pState, pCoeffs};
      *arm_fir_instance_q15 S = {numTaps, pState, pCoeffs};
      *arm_fir_instance_q7 S =  {numTaps, pState, pCoeffs};

where `numTaps` is the number of filter coefficients in the filter; `pState` is the address of the state buffer; `pCoeffs` is the address of the coefficient buffer.

Fixed-Point Behavior
  Care must be taken when using the fixed-point versions of the FIR filter functions. In particular, the overflow and saturation behavior of the accumulator used in each function must be considered. Refer to the function specific documentation below for usage guidelines.

## Function Documentation

void arm_fir_f32 | ( | const arm_fir_instance_f32 * | S,
|  | float32_t * | pSrc,
|  | float32_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *S | points to an instance of the floating-point FIR filter structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data.
  [in] | blockSize | number of samples to process per call.

Returns
  none.

Examples:
  arm_fir_example_f32.c, and arm_signal_converge_example_f32.c.

References arm_fir_instance_f32::numTaps, arm_fir_instance_f32::pCoeffs, and arm_fir_instance_f32::pState.

Referenced by main().

void arm_fir_fast_q15 | ( | const arm_fir_instance_q15 * | S,
|  | q15_t * | pSrc,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *S | points to an instance of the Q15 FIR filter structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data.
  [in] | blockSize | number of samples to process per call.

Returns
  none.

Scaling and Overflow Behavior:

  This fast version uses a 32-bit accumulator with 2.30 format. The accumulator maintains full precision of the intermediate multiplication results but provides only a single guard bit. Thus, if the accumulator result overflows it wraps around and distorts the result. In order to avoid overflows completely the input signal must be scaled down by log2(numTaps) bits. The 2.30 accumulator is then truncated to 2.15 format and saturated to yield the 1.15 result.

  Refer to the function `arm_fir_q15()` for a slower implementation of this function which uses 64-bit accumulation to avoid wrap around distortion. Both the slow and the fast versions use the same instance structure. Use the function `arm_fir_init_q15()` to initialize the filter structure.

References __SIMD32, _SIMD32_OFFSET, arm_fir_instance_q15::numTaps, arm_fir_instance_q15::pCoeffs, and arm_fir_instance_q15::pState.

IAR_ONLY_LOW_OPTIMIZATION_ENTER void arm_fir_fast_q31 | ( | const arm_fir_instance_q31 * | S,
|  | q31_t * | pSrc,
|  | q31_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *S | points to an instance of the Q31 structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block output data.
  [in] | blockSize | number of samples to process per call.

Returns
  none.

Scaling and Overflow Behavior:

  This function is optimized for speed at the expense of fixed-point precision and overflow protection. The result of each 1.31 x 1.31 multiplication is truncated to 2.30 format. These intermediate results are added to a 2.30 accumulator. Finally, the accumulator is saturated and converted to a 1.31 result. The fast version has the same overflow behavior as the standard version and provides less precision since it discards the low 32 bits of each multiplication result. In order to avoid overflows completely the input signal must be scaled down by log2(numTaps) bits.

  Refer to the function `arm_fir_q31()` for a slower implementation of this function which uses a 64-bit accumulator to provide higher precision. Both the slow and the fast versions use the same instance structure. Use the function `arm_fir_init_q31()` to initialize the filter structure.

References multAcc_32x32_keep32_R, arm_fir_instance_q31::numTaps, arm_fir_instance_q31::pCoeffs, and arm_fir_instance_q31::pState.

void arm_fir_init_f32 | ( | arm_fir_instance_f32 * | S,
|  | uint16_t | numTaps,
|  | float32_t * | pCoeffs,
|  | float32_t * | pState,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in,out] | *S | points to an instance of the floating-point FIR filter structure.
  [in] | numTaps | Number of filter coefficients in the filter.
  [in] | *pCoeffs | points to the filter coefficients buffer.
  [in] | *pState | points to the state buffer.
  [in] | blockSize | number of samples that are processed per call.

Returns
  none.

Description:

  `pCoeffs` points to the array of filter coefficients stored in time reversed order:

         {b[numTaps-1], b[numTaps-2], b[N-2], ..., b[1], b[0]}

  `pState` points to the array of state variables. `pState` is of length `numTaps+blockSize-1` samples, where `blockSize` is the number of input samples processed by each call to `arm_fir_f32()`.

Examples:
  arm_fir_example_f32.c, and arm_signal_converge_example_f32.c.

References arm_fir_instance_f32::numTaps, arm_fir_instance_f32::pCoeffs, and arm_fir_instance_f32::pState.

Referenced by main().

arm_status arm_fir_init_q15 | ( | arm_fir_instance_q15 * | S,
|  | uint16_t | numTaps,
|  | q15_t * | pCoeffs,
|  | q15_t * | pState,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in,out] | *S | points to an instance of the Q15 FIR filter structure.
  [in] | numTaps | Number of filter coefficients in the filter. Must be even and greater than or equal to 4.
  [in] | *pCoeffs | points to the filter coefficients buffer.
  [in] | *pState | points to the state buffer.
  [in] | blockSize | is number of samples processed per call.

Returns
  The function returns ARM_MATH_SUCCESS if initialization is successful or ARM_MATH_ARGUMENT_ERROR if `numTaps` is not greater than or equal to 4 and even.

Description:

  `pCoeffs` points to the array of filter coefficients stored in time reversed order:

         {b[numTaps-1], b[numTaps-2], b[N-2], ..., b[1], b[0]}

  Note that `numTaps` must be even and greater than or equal to 4. To implement an odd length filter simply increase `numTaps` by 1 and set the last coefficient to zero. For example, to implement a filter with `numTaps=3` and coefficients

          {0.3, -0.8, 0.3}

  set `numTaps=4` and use the coefficients:

          {0.3, -0.8, 0.3, 0}.

  Similarly, to implement a two point filter

          {0.3, -0.3}

  set `numTaps=4` and use the coefficients:

          {0.3, -0.3, 0, 0}.

  `pState` points to the array of state variables. `pState` is of length `numTaps+blockSize`, when running on Cortex-M4 and Cortex-M3 and is of length `numTaps+blockSize-1`, when running on Cortex-M0 where `blockSize` is the number of input samples processed by each call to `arm_fir_q15()`.

References ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, arm_fir_instance_q15::numTaps, arm_fir_instance_q15::pCoeffs, arm_fir_instance_q15::pState, and status.

void arm_fir_init_q31 | ( | arm_fir_instance_q31 * | S,
|  | uint16_t | numTaps,
|  | q31_t * | pCoeffs,
|  | q31_t * | pState,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in,out] | *S | points to an instance of the Q31 FIR filter structure.
  [in] | numTaps | Number of filter coefficients in the filter.
  [in] | *pCoeffs | points to the filter coefficients buffer.
  [in] | *pState | points to the state buffer.
  [in] | blockSize | number of samples that are processed per call.

Returns
  none.

Description:

  `pCoeffs` points to the array of filter coefficients stored in time reversed order:

         {b[numTaps-1], b[numTaps-2], b[N-2], ..., b[1], b[0]}

  `pState` points to the array of state variables. `pState` is of length `numTaps+blockSize-1` samples, where `blockSize` is the number of input samples processed by each call to `arm_fir_q31()`.

References arm_fir_instance_q31::numTaps, arm_fir_instance_q31::pCoeffs, and arm_fir_instance_q31::pState.

void arm_fir_init_q7 | ( | arm_fir_instance_q7 * | S,
|  | uint16_t | numTaps,
|  | q7_t * | pCoeffs,
|  | q7_t * | pState,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in,out] | *S | points to an instance of the Q7 FIR filter structure.
  [in] | numTaps | Number of filter coefficients in the filter.
  [in] | *pCoeffs | points to the filter coefficients buffer.
  [in] | *pState | points to the state buffer.
  [in] | blockSize | number of samples that are processed per call.

Returns
  none

Description:

  `pCoeffs` points to the array of filter coefficients stored in time reversed order:

         {b[numTaps-1], b[numTaps-2], b[N-2], ..., b[1], b[0]}

  `pState` points to the array of state variables. `pState` is of length `numTaps+blockSize-1` samples, where `blockSize` is the number of input samples processed by each call to `arm_fir_q7()`.

References arm_fir_instance_q7::numTaps, arm_fir_instance_q7::pCoeffs, and arm_fir_instance_q7::pState.

void arm_fir_q15 | ( | const arm_fir_instance_q15 * | S,
|  | q15_t * | pSrc,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *S | points to an instance of the Q15 FIR structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data.
  [in] | blockSize | number of samples to process per call.

Returns
  none.

Restrictions
  If the silicon does not support unaligned memory access enable the macro UNALIGNED_SUPPORT_DISABLE In this case input, output, state buffers should be aligned by 32-bit

Scaling and Overflow Behavior:

  The function is implemented using a 64-bit internal accumulator. Both coefficients and state variables are represented in 1.15 format and multiplications yield a 2.30 result. The 2.30 intermediate results are accumulated in a 64-bit accumulator in 34.30 format. There is no risk of internal overflow with this approach and the full precision of intermediate multiplications is preserved. After all additions have been performed, the accumulator is truncated to 34.15 format by discarding low 15 bits. Lastly, the accumulator is saturated to yield a result in 1.15 format.

  Refer to the function `arm_fir_fast_q15()` for a faster but less precise implementation of this function.

References __SIMD32, _SIMD32_OFFSET, arm_fir_instance_q15::numTaps, arm_fir_instance_q15::pCoeffs, and arm_fir_instance_q15::pState.

void arm_fir_q31 | ( | const arm_fir_instance_q31 * | S,
|  | q31_t * | pSrc,
|  | q31_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *S | points to an instance of the Q31 FIR filter structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data.
  [in] | blockSize | number of samples to process per call.

Returns
  none.

Scaling and Overflow Behavior:

  The function is implemented using an internal 64-bit accumulator. The accumulator has a 2.62 format and maintains full precision of the intermediate multiplication results but provides only a single guard bit. Thus, if the accumulator result overflows it wraps around rather than clip. In order to avoid overflows completely the input signal must be scaled down by log2(numTaps) bits. After all multiply-accumulates are performed, the 2.62 accumulator is right shifted by 31 bits and saturated to 1.31 format to yield the final result.

  Refer to the function `arm_fir_fast_q31()` for a faster but less precise implementation of this filter for Cortex-M3 and Cortex-M4.

References blockSize, arm_fir_instance_q31::numTaps, arm_fir_instance_q31::pCoeffs, and arm_fir_instance_q31::pState.

void arm_fir_q7 | ( | const arm_fir_instance_q7 * | S,
|  | q7_t * | pSrc,
|  | q7_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *S | points to an instance of the Q7 FIR filter structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data.
  [in] | blockSize | number of samples to process per call.

Returns
  none.

Scaling and Overflow Behavior:

  The function is implemented using a 32-bit internal accumulator. Both coefficients and state variables are represented in 1.7 format and multiplications yield a 2.14 result. The 2.14 intermediate results are accumulated in a 32-bit accumulator in 18.14 format. There is no risk of internal overflow with this approach and the full precision of intermediate multiplications is preserved. The accumulator is converted to 18.7 format by discarding the low 7 bits. Finally, the result is truncated to 1.7 format.

References blockSize, arm_fir_instance_q7::numTaps, arm_fir_instance_q7::pCoeffs, and arm_fir_instance_q7::pState.